# Resource Order #

When creating new items in the `.js` files, or when modifying existing items there, please list resources in the same order as they appear on the left panel of the game, which is the same order as they appear in the `resources.js` file.

To make this task easier, we have compiled a quick reference list of the resource names used in the code.

**PLEASE NOTE:** They keynames below appear as they do in the *`CODE`*, not in the game. Some of the keys are misspelled. Other keys use older names that are different from their in-game names. Regardless, the code will work only when using the keynames shown below.

The more obscure keynames have footnotes[^footnote] to help you identify them.

---

|:cat2:|   These are first   |       ...       | and these are last. |:cat2:|
|:----:|:-------------------:|:---------------:|:-------------------:|:--:|
||       catnip        | gflops[^gflops] |     bloodstone      ||
||        wood         |    hashrates    |        beam         ||
||      minerals       |      furs       |        slab         ||
||        coal         |      ivory      |        plate        ||
||        iron         |      spice      |        steel        ||
||      titanium       |    unicorns     |      concrate       ||
||        gold         |     alicorn     |        gear         ||
||         oil         |    necrocorn    |        alloy        ||
||       uranium       |      tears      |       eludium       ||
||     unobtainium     |      karma      |      scaffold       ||
||     antimatter      |     paragon     |        ship         ||
|| manpower[^manpower] |  burnedParagon  |       tanker        ||
||       science       |   timeCrystal   |      kerosene       ||
||       culture       | sorrow[^sorrow] |      parchment      ||
||        faith        |      relic      |     manuscript      ||
||       kittens       |      void       |      compedium      ||
||       zebras        | elderBox[^box]  |      blueprint      ||
||      starchart      |  wrappingPaper  |       thorium       ||
||    temporalFlux     |    blackcoin    |      megalith       ||

[Back to README.md](./README.md)

[^footnote]: ...like this.
[^manpower]: catpower
[^gflops]: gigaflops
[^sorrow]: Black Liquid Sorrow (BLS)
[^box]: present box (available for only two weeks per year, during December)
