WRaceButton = React.createClass({
    displayName: "WRaceButton",
    
    buttonLegacy: null,

    getInitialState: function() {
        return {
            collapsed: true
        };
    },

    componentWillMount: function(){
        var meta = this.props.meta;
    },

    render: function(){
        var tooltip = "",
            race = this.props.meta;

        if (!this.state.collapsed) {
            tooltip = this.renderTooltip(this.props.meta);
        }

        return $r(WStatelessCollapsibleSection, {
            title: race.title,
            ontoggle: this.toggle,
            collapsed: this.state.collapsed
        }, tooltip);
    },

    renderTooltip: function(meta){

        var race = meta;

        var content = dojo.create("div", {});
        var leftColumn = dojo.create("div", {}, content);
        var rightColumn = dojo.create("div",{}, content);

        var buys = race.buys[0];
        var res = game.resPool.get(buys.name);
        dojo.create("div", {
            innerHTML: "<span class='buys'>" + $I("trade.buys") + ": </span>" + (res.title || res.name) + " <span class='ammount'>" + buys.val + "</span>"
        }, leftColumn);

        var manpowerRes = game.resPool.get("manpower");
        var goldRes = game.resPool.get("gold");
        dojo.create("div", {
            innerHTML: "<span class='cost'>" + $I("trade.cost") + ": </span>" + (manpowerRes.title || manpowerRes.name) + " <span class='ammount'>" + 50 + "</span>, " +
            (goldRes.title || goldRes.name) + " <span class='ammount'>" + 15 + "</span>"
        }, leftColumn);

        
        var hasBcoinTrade = (game.science.get("blackchain").researched || game.resPool.get("blackcoin").value > 0);
        var leviathans = game.diplomacy.get("leviathans");
        var markerCap = game.religion.getZU("marker").val * 5 + 5;
        var leviathansInfoEnergy = leviathans.energy ? leviathans.energy + " / " + markerCap : "N/A";



        var currentSeason = game.calendar.getCurSeason().name;
        for (var j =0; j< race.sells.length; j++) {
            var s = race.sells[j];
            if (!game.diplomacy.isValidTrade(s, race)) {
                continue;
            }

            var tradeRatio = 1 + game.diplomacy.getTradeRatio();
			tradeRatio += game.diplomacy.calculateTradeBonusFromPolicies(race.name, game);

            var res = game.resPool.get(s.name);
			var average = s.value * tradeRatio * (1 + race.energy * 0.02) * (1 + (s.seasons ? s.seasons[currentSeason] : 0));
            
            var prefix = ( j === 0) ? "<span class='sells'>" + $I("trade.sells") + ": </span>" : "<span class='sells'></span>";
            var div = dojo.create("div", {
                innerHTML: prefix + (res.title || res.name) + " <span class='ammount'>"
                + game.getDisplayValueExt(average * (1 - s.width / 2), false, false, 0) + " - "
                + game.getDisplayValueExt(average * (1 + s.width / 2), false, false, 0) + "</span>"
            }, leftColumn);
        }
        if (race.name == "zebras") {
            var zebraRelationModifierTitanium = game.getEffect("zebraRelationModifier") * 
                game.bld.getBuildingExt("tradepost").meta.effects["tradeRatio"];

            var titanium = game.resPool.get("titanium");
            var displayedVal = game.getDisplayValueExt((1.5 + game.resPool.get("ship").value * 0.03) * 
                (1 + zebraRelationModifierTitanium), false, false, 0);
            dojo.create("div", {
                    innerHTML: "<span class='sells'></span>" + (titanium.title || titanium.name) + " <span class='tradeAmount'>" + displayedVal + " - " + displayedVal + "</span>"
                }, leftColumn);
        }
        

        var tradeMax = game.diplomacy.getMaxTradeAmt(race);

        // Update tradeHalfHref Link
        var tradeHalf = Math.floor(tradeMax / 2);
        var tradeHalfText = "x" + game.getDisplayValueExt(tradeHalf, null, false, 0);
        // Change display
        //dojo.setStyle(this.tradeHalfHref.link, "display", this.game.diplomacy.hasMultipleResources(this.race, 50) ? "" : "none");

        // Update tradeFifthHref Link
        var tradeFifth = Math.floor(tradeMax / 5);
        var tradeFifthText = "x" + game.getDisplayValueExt(tradeFifth, null, false, 0);
        // Change display
        //dojo.setStyle(this.tradeFifthHref.link, "display", this.game.diplomacy.hasMultipleResources(this.race, 25) ? "" : "none");

        
        return $r("div", {}, [
            $r("div", { className: "button-tooltip", dangerouslySetInnerHTML: { __html: content.outerHTML}}),
            (race.name == "leviathans") ? $r("div", null, 
                $r("span", {className: "kg-instructional-text", dangerouslySetInnerHTML: { __html: "Energy: " + leviathansInfoEnergy +
                "<br />Time to leave: " + game.toDisplayDays(leviathans.duration) + 

                (game.science.get("blackchain").researched ? ("<br/> B-coin price: <span style='cursor:pointer' title='"+ game.calendar.cryptoPrice + "'>" +
					game.getDisplayValueExt(game.calendar.cryptoPrice, false, false, 5) + "R</span>" ) : "")
                }})
            ) : null,
            $r("div", { className: "bld-tooltip-buttons"}, [
                $r("p", { className: "buttons-row"},
                    [
                        $r("a", { 
                            key: "one", 
                            className: "button kg-button-trade button-raised" + (game.diplomacy.hasMultipleResources(race, 1)? "" : " wgt-disabled"), 
                            href: "#", 
                            'data-res-amount': 1,
                            onClick: this.trade
                        }, $I("btn.trade") ),
                        race.name == "leviathans" ? $r("a", {
                            key: "feed",
                            href: "#",
                            className: "button kg-button-trade button-raised",
                            onClick: game.diplomacy.feedElders
                        }, $I("btn.feed")) : null,
                        $r("a", { 
                            key: "fifth",
                            className: "button kg-button-trade button-raised", 
                            href: "#", 
                            'data-res-amount': tradeFifth,
                            style: {
                                display: game.diplomacy.hasMultipleResources(race, 25)? "" : "none"
                            },
                            onClick: this.trade     
                        }, tradeFifthText ),
                        $r("a", { 
                            key: "half",
                            className: "button kg-button-trade button-raised", 
                            href: "#", 
                            'data-res-amount': tradeHalf,
                            style: {
                                display: game.diplomacy.hasMultipleResources(race, 50)? "" : "none"
                            },
                            onClick: this.trade     
                        }, tradeHalfText ),
                        $r("a", { 
                            key: "all",
                            className: "button kg-button-trade button-raised" + (game.diplomacy.hasMultipleResources(race, 1)? "" : " wgt-disabled"), 
                            href: "#", 
                            onClick: this.tradeAll
                        }, game.diplomacy.hasMultipleResources(race, 25) ? $I("btn.all"): "x" + game.getDisplayValueExt(tradeMax, null, false, 0) )
                    ]
                ),
                //embassies
                /*((race.name != "leviathans") && 
                    $r("p", { className: "buttons-row"}), [
                        $r("a", { 
                            key: "embassy",
                            className: "button kg-button-trade button-raised", 
                            href: "#", 
                            onClick: this.buildEmbassy
                        },  
                            $I("trade.embassy",[ race.embassyLevel ])
                        )
                ])*/
                 
                (race.name != "leviathans") && $r(WButtonModern, {
                    name: $I("trade.embassy.open"),
                    description: $I("trade.embassy.desc"),
                    prices: race.embassyPrices,
                    race: race,
                    controller: new classes.diplomacy.ui.EmbassyButtonController(game),
                    handler: dojo.partial(function(race){
						game.diplomacy.buildEmbassy(race);
					}, race)
                }),   

                ((race.name == "leviathans") && hasBcoinTrade) && 
                    $r("p", { className: "buttons-row"},
                        [
                            $r("a", { 
                                key: "buy",
                                className: "button kg-button-trade button-raised", 
                                href: "#", 
                                onClick: this.buyCoin
                            }, $I("trade.bcoin.buy")),
                            $r("a", { 
                                key: "sell",
                                className: "button kg-button-trade button-raised", 
                                href: "#", 
                                onClick: this.sellCoin
                            }, $I("trade.bcoin.sell")) 
                        ]
                    )
            ])
        ]);
    },

    toggle: function(){
        this.setState({
            collapsed: !this.state.collapsed
        });
    },

    trade: function(race){
        game.diplomacy.tradeMultiple(this.props.meta, event.target.dataset.resAmount);
    },

    tradeAll: function(){
        game.diplomacy.tradeAll(this.props.meta);
    },

    buyCoin: function(){
        game.diplomacy.buyBcoin();
    },

    sellCoin: function(){
        game.diplomacy.sellBcoin();
    },

    buildEmbassy: function(race){
        game.diplomacy.buildEmbassy(race);
    },
});


WDiplomacyTab = React.createClass({
    displayName: "WDiplomacyTab",

    mixins: [GameUpdateTrackerMixin],

    onGameUpdate: function(game) {
        this.setState({
            game: game
        });
    },

    getInitialState: function() {
        return {
            game: game
        };
    },
    
    render: function() {

        var descriptionDiv = $r('div', {className: "diplomacyDesc"}, [
            $r('p', {
                dangerouslySetInnerHTML: { __html: $I("trade.send.caravan.desc") }
            })
        ]);
        var exploreBtn = $r(WButtonModern, {
            name: $I("trade.send.explorers"),
            description: $I("trade.send.explorers.desc"),
            prices: [{ name: "manpower", val: 1000}],
            controller: new classes.trade.ui.SendExplorersButtonController(game),
            mainButtonTitle:$I("trade.send.explorers")
        });

        var raceBtns = [
            descriptionDiv, 
            exploreBtn
        ];

        for (var i = 0; i< game.diplomacy.races.length; i++){
            var race = game.diplomacy.races[i];
            if (!race.unlocked){
                continue;
            }

            raceBtns.push(
                $r(WRaceButton, {meta: race })
            );
        }

        return  $r("div", {className: "list-block accordion-list"},
            $r("ul", { style: {padding : "10px"}},
                [
                    raceBtns
                ])
        );
    }
});